<script setup lang="ts">
import { computed } from 'vue';
import SdgButton from './SdgButton.vue';
import type { Answer } from '../types/Answer';

const props = defineProps<{
  answer?: Answer;
  class?: string;
}>();

const emit = defineEmits(['onAnswerClick']);

const classes = computed(() => props.class);

const color = computed(() => {
  if (!props.answer) {
    return 'bg-slate';
  }
  if (props.answer.hasBeenPicked && props.answer.isCorrectAnswer) {
    return 'bg-green-600';
  }
  if (props.answer.hasBeenPicked) {
    return 'bg-red-900';
  }
  return 'bg-sdg-blue';
});

const isDisabled = computed(() => {
  if (!props.answer) {
    return false;
  }
  return props.answer.hasBeenPicked;
});

function onAnswerClick() {
  emit('onAnswerClick', props.answer);
}
</script>

<template>
  <SdgButton :class="classes" :disabled="isDisabled" :color="color" @onClick="onAnswerClick">
    <span>{{ answer?.buttonText }}</span>
    <slot />
  </SdgButton>
</template>
